Bug 1639833 - [RFE] Enabling CRUSH device classes should not incur data movement in the cluster
Summary: [RFE] Enabling CRUSH device classes should not incur data movement in the clu...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Ceph Storage
Classification: Red Hat
Component: RADOS
Version: 3.1
Hardware: Unspecified
OS: Unspecified
high
high
Target Milestone: z2
: 3.2
Assignee: Josh Durgin
QA Contact: Manohar Murthy
URL:
Whiteboard:
: 1638228 (view as bug list)
Depends On:
Blocks: 1629656
TreeView+ depends on / blocked
 
Reported: 2018-10-16 17:30 UTC by Mike Hackett
Modified: 2019-04-30 15:57 UTC (History)
14 users (show)

Fixed In Version: RHEL: ceph-12.2.8-113.el7cp Ubuntu: ceph_12.2.8-96redhat1xenial
Doc Type: Enhancement
Doc Text:
.Upgrading to the latest version no longer causes cluster data movement Previously, upgrading a {product} cluster to the latest version when CRUSH device classes were enabled, the `crushtool` utility rebalanced data in the cluster because of changes in the CRUSH map. This data movement should not have occurred. With this update, a reclassify functionality is available to help transition from older CRUSH maps that maintains parallel hierarchies for OSDs of different types to a modern CRUSHmap that makes use of the device class feature without triggering data movement.
Clone Of:
Environment:
Last Closed: 2019-04-30 15:56:43 UTC
Target Upstream Version:


Attachments (Terms of Use)
updated crush map (43.91 KB, application/octet-stream)
2018-10-23 19:27 UTC, Sage Weil
no flags Details


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2019:0911 None None None 2019-04-30 15:57:00 UTC

Description Mike Hackett 2018-10-16 17:30:13 UTC
Description of problem:
Currently when a legacy cluster is upgraded to Luminous (RHCS 3.y) and CRUSH device classes are enabled CRUSH will rebalance data in the cluster due to a change in the CRUSH map.
Reclassifying devices should not incur a data movement as we are only applying a label.

Upstream PR: 
https://github.com/ceph/ceph/pull/24502

Version-Release number of selected component (if applicable):
3.y

Comment 4 Sage Weil 2018-10-17 16:19:30 UTC
I am finalizing a tool to handle this in https://github.com/ceph/ceph/pull/24502

Comment 5 Josh Durgin 2018-10-17 21:37:14 UTC
*** Bug 1638228 has been marked as a duplicate of this bug. ***

Comment 13 Sage Weil 2018-10-23 19:27:40 UTC
Created attachment 1496814 [details]
updated crush  map

Updated CRUSH map that uses hdd-sas and hdd-sata classes.  All mappings should be identical to before (no PGs should move).

Comment 26 errata-xmlrpc 2019-04-30 15:56:43 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2019:0911


Note You need to log in before you can comment on or make changes to this bug.